

var ie = false;
var firefox = false;
var opera = false;
var safari = false;
var chrome = false;
var ns = false;
var ns6 = false;
var displayInfoMessges = false;
var displayDebugMessges = true;
var keybuf=[];
var timeout;
var sending=0;
var useGet = false;
var error_timeout;
var rmax = refreshInterval;

// These should now be set externally
//var refreshInterval = 100;
//var keyDelay = 350;
//var slowRefreshInterval = 5000;

// Roughly detect the browser

if ((i = navigator.userAgent.indexOf('MSIE')) >= 0) {
   ie = true;
} else if ((i = navigator.userAgent.indexOf('Firefox')) >= 0) {
   firefox = true;
} else if ((i = navigator.userAgent.indexOf('Opera')) >= 0) {
   opera = true;
} else if ((i = navigator.userAgent.indexOf('Chrome')) >= 0) {
   chrome = true;
} else if ((i = navigator.userAgent.indexOf('Safari')) >= 0) {
   safari = true;
} else if(navigator.appName.indexOf("Netscape") >= 0 && _info != null && ((_info.indexOf("Win") > 0 && _info.indexOf("Win16") < 0 && java.lang.System.getProperty("os.version").indexOf("3.5") < 0) || (_info.indexOf("Sun") > 0) || (_info.indexOf("Linux") > 0) || (_info.indexOf("AIX") > 0) || (_info.indexOf("OS/2") > 0) || (_info.indexOf("IRIX") > 0))) {
   ns = true;
   ns6 = ((_ns == true) && (_info.indexOf("Mozilla/5") >= 0));
}

function t_keypress(ev) {
	if (!ev) 
		var ev=window.event;
		
	// Key Code - Should be -1 for ordinary ASCII keys
	var kc;
	
	// Key Character - Any ordinary ASCII keys. Empty for NON ascii keys
	var k="";
	
	// Modifiers
	var ctrl = ev.ctrlKey;
	var alt = ev.altKey;
	var shift = ev.shiftKey;
	
	if (ev.keyCode)
		kc=ev.keyCode;
	if (ev.which && (!ev.type == "keydown" || ev.type == "keypress" ) )
		kc=ev.which;
		
	// Alt
	if (alt) {
		if(kc == 9 || (firefox && kc == 192)) {
			return true;
		}
		else if (kc>=65 && kc<=90)
				kc+=32;
			if (kc>=97 && kc<=122) {
				k=String.fromCharCode(27)+String.fromCharCode(kc);
			}
	// Ctrl
	} else if (ctrl) {
		// Don't send Ctrl+Tab - let browser / WM handle it
		if(kc == 9) {
			return true; 
		}
		else if (kc>=65 && kc<=90) {
			k=String.fromCharCode(kc-64); // Ctrl-A..Z
		}
		else if (kc>=97 && kc<=122) k=String.fromCharCode(kc-96); // Ctrl-A..Z
		else if (kc==54)  k=String.fromCharCode(30); // Ctrl-^
		else if (kc==109) k=String.fromCharCode(31); // Ctrl-_
		else if (kc==219) k=String.fromCharCode(27); // Ctrl-[
		else if (kc==220) k=String.fromCharCode(28); // Ctrl-\
		else if (kc==221) k=String.fromCharCode(29); // Ctrl-]
		else if (kc==219) k=String.fromCharCode(29); // Ctrl-]
		else if (kc==219) k=String.fromCharCode(0);  // Ctrl-@
		else if (kc==91) k=String.fromCharCode(27); // Ctrl-[
		else if (kc==93) k=String.fromCharCode(29); // Ctrl-]
		else if (kc==47) k=String.fromCharCode(31);  // Ctrl-`
		else if (kc==96) k=String.fromCharCode(30);  // Ctrl-`
		else if (kc==92) k=String.fromCharCode(28);  // Ctrl-`
		
		if(k.length > 0) {
			kc = -1;
			ctrl = false;
		}
	//
	} else if (ev.which==0 || ( ev.type == "keydown" ) ) {
		if (kc==9) k=String.fromCharCode(9);  // Tab
		else if (kc==8) k=String.fromCharCode(127);  // Backspace
		else if (kc==27) k=String.fromCharCode(27); // Escape
		else {
			if (kc==45) kc=0x9b;   // Ins
			if (kc==46) kc=0x7f;   // Del
		}
	} else {	
		if(kc == 13) {
			kc = 10;
		}
		else {
			if(kc == 16 || kc == 17 || kc == 18) {
				// Stops opera sending modifiers only keys
				k = '';
				kc = -1;
			}
			else if(kc != 8) {
				if(kc == 43) {
					// I have no idea!
					k = '+';
				}
				else {
					k=String.fromCharCode(kc);
				}
				kc = -1;
			}
		}
	}
	
	if(kc >= 0 || k.length > 0) {
		keyMods = 0;
		if(ctrl)
			keyMods += 1;
		if(shift)
			keyMods += 2;
		if(alt)
			keyMods += 4;
		var kev = '&k=' + kc + ',' + keyMods;
		if(k != '') {
			kev += ',' + encodeURIComponent(k);
		}	
		t_queue(kev);
	}
	
	// Stop the event propogating
	ev.cancelBubble=true;
	if (ev.stopPropagation) {
		ev.stopPropagation();
	}
	if (ev.preventDefault) {
		ev.preventDefault();
	}
	return false; 
}

function t_keydown(ev) {
	if (!ev) {
		var ev=window.event;
	}
	
	if (ie || safari || chrome) {
//		s="kd keyCode="+ev.keyCode+" which="+ev.which+" shiftKey="+ev.shiftKey+" ctrlKey="+ev.ctrlKey+" altKey="+ev.altKey;
//		debug(s);
		o={9:1,8:1,27:1,33:1,34:1,35:1,36:1,37:1,38:1,39:1,40:1,45:1,46:1,112:1,
			113:1,114:1,115:1,116:1,117:1,118:1,119:1,120:1,121:1,122:1,123:1, 17:1 };
		if (o[ev.keyCode] || ev.ctrlKey || ev.altKey) {
			ev.which=0; // This has no effect in Safari/Chrome and possibly later IE version so we use an alternative method in t_keypress (check for event type)
			return t_keypress(ev);
		}
	}
}

function t_queue(s) {
	keybuf.unshift(s);
	if(sending==0) {
		window.clearTimeout(timeout);
		timeout=window.setTimeout(t_update,keyDelay);
	}
}

function t_update() {
	if(sending==0) {
		sending=1;
		var query = 'u=';
		while(keybuf.length>0) {
			query += keybuf.pop();
		}
		sending=0;		
		var requestHeaders = null;
		if(ie) {
			requestHeaders = new Array(2);
			requestHeaders[0] = "If-Modified-Since";
			requestHeaders[1] = "Sat, 1 Jan 2000 00:00:00 GMT";
		}
		t_cmd(query, requestHeaders);
	}
}

function t_cmd(cmd, requestHeaders) {
	if ( typeof( window[ 't_params' ] ) != "undefined" ) {
		for(i in t_params) {
			cmd += '&' + i + '=' + encodeURI(t_params[i]);
		}
	}
	
	var xmlhttp = null;
	
	// code for Mozilla, etc.
	if (window.XMLHttpRequest) {
		xmlhttp=new XMLHttpRequest();
	}
	// code for IE
	else if (window.ActiveXObject) {
		 xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
	}
	if (xmlhttp!=null) {
		xmlhttp.open("POST", 't', true);
		if(requestHeaders != null) {
			for(i = 0 ; i < requestHeaders.length; i++) {
				xmlhttp.setRequestHeader(requestHeaders[i], requestHeaders[++i]);
			}
		}
		xmlhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
		xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlhttp.setRequestHeader("Content-length", cmd.length);
		xmlhttp.send(cmd);
		xmlhttp.onreadystatechange = function() {
			if (xmlhttp.readyState==4) {
		  		t_handle_response(xmlhttp);
				timeout=window.setTimeout(t_update,rmax);
		  	}
		};
	}
}

function t_disconnect() {
	t_queue('&d=');
}

function t_reset() {
	t_queue('&r=');
}

function t_paste() {
}

function t_handle_response(transport) {
	var update = false;
	window.clearTimeout(error_timeout);
	var responseText = transport.responseText;
 	var status = transport.getResponseHeader('X-WebTerm-Status');
 	var content  = transport.getResponseHeader('X-WebTerm-Content');
	if(200 == transport.status) {
		// Update
 		t_update_display(responseText);

		if(content == 'none') { 		
			// No updates available, continue refreshing but back off a bit
			rmax*=2;
			if(rmax>slowRefreshInterval) {
				rmax=slowRefreshInterval;
			}	
			update = true;
		}
		else {
	 		// Disconnected?
	 		if('disconnected' == status) {
				// Disconnected, stop updating
				$('disconnect').disabled = true;
				$('paste').disabled = true;
				$('reset').disabled = true;
	 		}
	 		else { 
				rmax = refreshInterval;
				update = true;	
			}
		}
	}
	else {		  		
		// Unknown code
		t_update_display('Unknown response code ' + transport.status + '. ' + transport.responseText);
	}	
 	return update;
}

function t_update_display(responseText) {
	if(responseText) {
		$('virtualSession').update(responseText);
	}
}
function t_add_load_event(func) { 
	var oldonload = window.onload; 
	if (typeof window.onload != 'function') { 
		window.onload = func; 
	} else { 
		window.onload = function() { 
			if (oldonload) { 
				oldonload(); 
			} 
			func(); 
		} 
	} 
}

function t_add_unload_event(func) { 
	var oldonunload = window.onbeforeunload; 
	if (typeof window.onbeforeunload != 'function') { 
		window.onbeforeunload = func; 
	} else { 
		window.onbeforeunload = function() { 
			if (oldonunload) { 
				oldonunload(); 
			} 
			func(); 
		} 
	} 
} 

function t_init() {
	timeout=window.setTimeout(t_update,rmax);
}

function t_uninit() {
	t_cmd('d', null);
}

// Trap keyboard events
document.onkeypress = t_keypress;
document.onkeydown = t_keydown;
t_add_load_event(t_init);
t_add_unload_event(t_uninit);